Welcome
=======
This is a test harness for the Perforce Unix SDP (Server Deployment Package). 
It used to use Vagrant, but has now been converted to use Docker containers (see older
versions of this file for Vagrant instructions).

Requirements
------------
To use this bundle you will need to download and install the following free tool:

https://docs.docker.com/engine/installation/

If you're not familiar with Docker, it is building up a huge momentum because of its
sweet spot functionality which addresses fast creation of virtual environments and
the ability to ship images with all dependencies between different environments.

https://docs.docker.com/mac/

Usage
-----
1) Create a workspace named YourID.test_sdp_dev.sdp (replacing YourID with your account name in the Perforce Public Depot). The root directory should be the directory where this README.md file was found, such that it creates the `sdp` folder below this directory and maps some test files in this directory. The `View:` of the workspace should look like this sample:

    View:

    p4 -s -c YourID.test_sdp_dev sync

3) From the command prompt run run_docker_tests.sh from the root directory. The first time 
you run it will take a while as it builds the initial docker images!

Workflow for testing
--------------------

Build your docker image (from workspace root):

1) docker build --rm=true -t=centos6-sdp -f sdp/test/docker/Dockerfile.centos6.sdp sdp/test/docker

How to run all tests:

1) docker run --rm -v $PWD/sdp:/sdp centos6-sdp /p4/docker_entry.sh

How to interactively poke around inside the container:

1) docker run --rm -v $PWD/sdp:/sdp -it centos6-sdp /bin/bash
2) Run 'su - perforce' to become user perforce (home directory is /p4)
3) /p4/test_sdp.sh

Substitute 'centos' for 'ubuntu' for different distribution in above commands.

Can run new tests:

    docker-compose up -d


Then:

    docker exec sdp_c6master_1 /sdp/Server/test/reset_sdp.sh -no_ssl -B -fast -no_sd
